/*************************************************************************/
// author : Sven Goethel - Stapenhorststrasse 35a - 33615 Bielefeld
//
/*
 *  Datei           : strclass.h
 *  Inhalt          : Deklaration der Klasse :
 *                        o StrClass
 *  Programmierer   : Sven Goethel
 *                      Stapenhorststr.35a
 *                      33615 Bielefeld
 *                      0521/139228
 *  Erstellungsdatum: 05.05.1994
 *  nderungsdatum  : 22.11.1994
 *  Projekt         : ...
 *  Verzeichnis     :
 *  Dokumentation   : ...
 *
 *    PUBLIC DOMAIN ....
 *
 *  $Log: strclass.h $
 *  Revision 1.4  1995/04/07 16:54:58  Sven_Goethel_DFP
 *  *** empty log message ***
 *  Revision 1.3  1995/04/04 10:37:37  Sven_Goethel
 *  *** empty log message ***
 *  Revision 1.2  1994/12/15 15:28:30  Sven_Goethel
 *  the very first check in !!!
 *  all files contains the log message now !!!
 *  Sven Goethel, Bielefeld 14.12.1994 !!!
 *  
 *  Revision 1.1  1994/12/15 15:18:46  Sven_Goethel
 *  Initial revision
 *
 */
/*************************************************************************/

# ifndef _STRCLASS_H
  # define _STRCLASS_H

  # include <iostream.h>
  # include <stdio.h>
  # include <string.h>
  # include "interror.h"
  # include <malloc.h>
  # include "coreleft.h"
  # include "bool.h"

  class StrClass {

  friend ostream& operator<< (ostream& OS, StrClass& str);

  public:
     StrClass(void) { StrPtr=NULL; }
     StrClass(const StrClass &m) { copy(m.StrPtr); }
     StrClass(const char *m) { copy(m); }
     ~StrClass(void) { dest(); }
     void AssignDouble(double m);
     StrClass& operator=(const StrClass&);
     // not using the implicit conversion, because the costs of run-time ...
     StrClass& operator=(const char *);
     void StrCat(const StrClass &m);
     // the standarised operator at Bjarne Stroustrup's suggestion.
     StrClass& operator+=(const StrClass &m) { StrCat(m); return *this; }
     int operator==(const StrClass &m) const;
     int operator!=(const StrClass &m) const;
     int operator>=(const StrClass &m) const;
     int operator<=(const StrClass &m) const;
     int operator>(const StrClass &m) const;
     int operator<(const StrClass &m) const;
     operator const char *(void) const { return StrPtr; }
     // operator char *(void) { return StrPtr; }
     char & operator[](int i) { return StrPtr[i]; }
     char operator[](int i) const { return StrPtr[i]; }
     int laenge(void) const;
     operator int() { return laenge(); }
     // rather old, but still a member-function because of compatibility ... :
     char *GetStrPtr(void) { return StrPtr; }
     const char *GetStrPtr(void) const { return StrPtr; }
     
     // here we have a little more power to modify strings ...
     
     int Chk4SubStr(const StrClass &SubStr, int StartIndex=0);  // return : index of found SubStr or -1
     
     int DelSubStr(const StrClass &SubStr, int StartIndex=0);  // return : index of deleted substr or -1
   int DelAllSubStr(const StrClass &SubStr); // return number of deleted sub strings ..
   
   bool InsertSubStr(const StrClass &SubStr, int Index);
   
   int SubstSubStr(const StrClass &SubStr, const StrClass &Substitute, int StartIndex=0); // return: index of subst or -1
   int SubstAllSubStr(const StrClass &SubStr, const StrClass &Substitute); // return number of substitutions
   
   void DelAllXtraWhiteSpaces();
     
     // some File - String Funktions, which i included here for service ....
     // (I am not worry about the memory-overhead if they won't be used.)
     int ChkStringInFile(const StrClass &FName);
     int DelStringInFile(const StrClass &FName);
  private:
    int DoStringInFile(const StrClass &FName, int Delete);
    void dest();
    void copy(const char *);
    char *StrPtr;
    static const char *TmpFileName;
  };

  // the global operator at Bjarne Stroustrup's suggestion.
  StrClass operator+(const StrClass &m, const StrClass &n) ; 

  ostream& operator<< (ostream& OS, StrClass& str);

# endif
